//Debug CONSOLE
var debugMode = false;

// Write to the debug div when in Safari.
// Send a simple alert to Console when in Dashboard.
function DEBUG(str) {
    if (debugMode) {
	if (window.widget) {
	    alert(str);
	} else {
	    var debugDiv = document.getElementById('debugDiv');
	    debugDiv.appendChild(document.createTextNode(str));
	    debugDiv.appendChild(document.createElement("br"));
	    debugDiv.scrollTop = debugDiv.scrollHeight;
	}
    }
}

// Toggle the debugMode flag, but only show the debugDiv in Safari
function toggleDebug() {
    debugMode = !debugMode;
    if (debugMode == true && !window.widget) {
	document.getElementById('debugDiv').style.display = 'block';
    } else {
	document.getElementById('debugDiv').style.display = 'none';
    }
}

/*
 * Presentation javascript code
 * This file should contain all the UI support junk 
 */

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    // toSize(backSize); //resize the widget

    if (window.widget)
	widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing

    front.style.display="none";		// hide the front
    back.style.display="block";		// show the back

    if (window.widget)
	setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

    document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
    // toSize(backSize); //resize the widget
    // resizeBy(0,200);
}
// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    // toSize(frontSize);   

    if (window.widget)
	widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front

    back.style.display="none";			// hide the back
    front.style.display="block";		// show the front

    if (window.widget)
	setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
    // toSize(frontSize);
    ///  resizeBy(0,-100);   
}


//mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
    if (!flipShown)			// if the preferences flipper is not already showing...
    {
	if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
	{
	    clearInterval (animation.timer);
	    animation.timer  = null;
	}

	var starttime = (new Date).getTime() - 13; 		// set it back one frame

	animation.duration = 500;												// animation time, in ms
	animation.starttime = starttime;										// specify the start time
	animation.firstElement = document.getElementById ('flip');		// specify the element to fade
	animation.timer = setInterval ("animate();", 13);						// set the animation function
	animation.from = animation.now;											// beginning opacity (not ness. 0)
	animation.to = 1.0;														// final opacity
	animate();																// begin animation
	flipShown = true;														// mark the flipper as animated
    }
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
    if (flipShown)
    {
	// fade in the flip widget
	if (animation.timer != null)
	{
	    clearInterval (animation.timer);
	    animation.timer  = null;
	}

	var starttime = (new Date).getTime() - 13;

	animation.duration = 500;
	animation.starttime = starttime;
	animation.firstElement = document.getElementById ('flip');
	animation.timer = setInterval ("animate();", 13);
	animation.from = animation.now;
	animation.to = 0.0;
	animate();
	flipShown = false;
    }
}
// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();


    T = limit_3(time-animation.starttime, 0, animation.duration);

    if (T >= animation.duration)
    {
	clearInterval (animation.timer);
	animation.timer = null;
	animation.now = animation.to;
    }
    else
    {
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
	animation.now = computeNextFloat (animation.from, animation.to, ease);
    }

    animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


//Code above the point was taken verbatim from the Goodbye World Example
/// ==SNIP===
var frontSize = [ 315,146 ];
var backSize  = [ 297, 220 ];


var waitingForInformation=1;
var RSData = {
    waitingForData:null,
    updater:null,
    autoupdater:null,
    delta:10,//update every 10 seconds/TImer will happen every 5 seconds
    //@TODO:Put these in info.plist
    update_check_delta:3600, //Check for updates ever hour
    last_update: 0,
    newVersionUrl:undefined,
    cache:new RadioDataCache(),
    stationList:[],
    genreList:[],
    cityList:[],
    activeStations:[],//active stations in the criteria list. 
    activeStationId:-1, //ID of active station and channel no
    activeStationUID:-1,
    checkConnection:0,
    streamUpdater:null,
    lastUiState:null,
    itunesurl:null,
    hasItunes:false,
    visible:true
};

//Request station information Asynchronously
//
function onStationList(info){
    DEBUG("GOT STATION INFORMATION:" + info);
    waitingForInformation=0;
    RSData.stationList=info;
}

function onCityList(lst){
    DEBUG("GOT CITY LIST:" + lst);
    RSData.cityList = lst.sort();
    RSData.cityList.push("-ALL-");
}

function onGenreList(lst){
    DEBUG("GOT GENRE LIST:" + lst);
    RSData.genreList=["-ALL-"].concat(lst.sort());
}

function withPrivilige(p,func){
    try {
	//    if(netscape)
	//        netscape.security.PrivilegeManager.enablePrivilege(p);
	func();
	//    netscape.security.PrivilegeManager.enablePrivilege("UniversalPreferencesRead");
    }catch(e){
	DEBUG("Error  Getting privilige"+ e.message);
    }

}

function getLists()
{
    RadioSherpa.getCityList(onCityList);
    RadioSherpa.getGenreList(onGenreList); 
}

function handle_exceptions(x, w, req)
{
    DEBUG("API-ERROR:(" + w + ")" + printEx(x) );
    //+ (req)?dumpObj(req):""); 
}

/**
 * Initialize RadioSherpa Data we will use  
 * do a background request for station information.
 *  and populate the vars if we get it
 */
function initRSData() {
    //Setup the debug hook to our console
    RadioSherpa.Config.debug=DEBUG;
    RadioSherpa.Config.exception=handle_exceptions;
    
    DEBUG("Requesting Station List");
    withPrivilige("UniversalBrowserRead  UniversalBrowserWrite", getLists);
    
    RSData.vlcDownloadUrl= WidgetMeta.getKeyValue("Info.plist","VlcDownloadUrl") || "http://www.videolan.org/vlc/download-macosx.html";
    RSData.widgetSite= WidgetMeta.getKeyValue("Info.plist","WidgetRsLink") || "http://www.radiosherpa.com";
    
    try{
	RSData.hasItunes=true;
	//detectItunes();
    }catch(e){
	DEBUG("ERROR DETECTING ITUNES");
    }
}

function populateStationList(elem,_data)
{
    var data=_data || RadioSherpa.getStationList();

}

function on_dashboard_show(){
    DEBUG("WIDGET-SHOWN");
    RSData.visible=true;
    startRadioDataLoop();
}

function on_dashboard_hide(){
    DEBUG("WIDGET-HIDDEN");
    RSData.visible=false;
    if(RSData.updater) RSData.updater.stop();
}

/*
 * Entry point into js code. called by Body::onLoad
 * asynchronously requests genre and category lists.
 * Setup stream data table,
 * Setup front and back variables
 * and initialized sizes of faces for the widget.
 */
function initialize(){
    if(window.widget){
	widget.onshow = on_dashboard_show;
	widget.onhide = on_dashboard_hide;
    }else{
	if(WidgetMeta.getKeyValue("Info.plist","DebugMode")){
            toggleDebug();
	}
    }

    DEBUG("RUNNING INITIALIZE()");
    initRSData();
    initBackVars();
    initFrontVars();
    clearFrontPanel();
    initUserData();
    //minor corrections 
    frontSize = [ 297,121 ];
    //`backSize  =[ $("front").width, $("back").height  ];
    DEBUG("BACK IS " + backSize[0] + " by " + backSize[1] );
    if(window.widget)resizeBy(50,200);
    if(!is_IE()){
	RadioStreams.useVLC(0);
    }
    initAutoUpdateLoop();
}
/**
 * Wording. 
 * 
 */
var Presentation = {
    //Statement placed in Station list indicating to user to select a station
    ChooseStatement:"Choose a station",
    //Song Name when None|unknown or null or blank is returned from API
    NoDataStatement: "Schedule Not Available"
};

/**
 * Element on front of widget
 */
var frontVars = {
    songTxt:null,
    artistTxt:null,
    albumTxt:null,
    stationList:null,
    defCover:null,
    realCover:null,
    playerContainer:null,
    statusIndicator:null
};

/**
 * Element on back fo widget
 */
var backVars= {
    stationLabel : null,
    stationList : null,
    genreList : null,
    cityList : null,
    divStationInfo : null,
    btnSelectStation : null
};
var UserData={
    cityPrefs:null,
    genrePrefs:null,
    stationPref:null
};

function initBackVars(){
    backVars.cityListDiv=document.getElementById("cboCitiesDiv");
    backVars.cityList=function() { return document.getElementById("cboCities"); };
    backVars.cityListOpts={
	clazz:'prefCombo',id:'cboCities',onchange:'',style:''
    };
    backVars.genreList=function() { return  document.getElementById("cboGenres"); };
    backVars.genreListDiv=document.getElementById("cboGenresDiv");
    backVars.genreListOpts= {
	clazz:'prefCombo',id:'cboGenres',onchange:'',style:'',multiple:1
    };
    backVars.stationList=document.getElementById("cboStations");
    backVars.stationLabel=document.getElementById("lblStations");
    backVars.divStationInfo=document.getElementById("divStationInfo");
    backVars.btnSelectStation=document.getElementById("btnSelectStation");
}

function initFrontVars(){
    frontVars.songTxt=document.getElementById("songTxt");
    frontVars.artistTxt=document.getElementById("artistTxt");
    frontVars.albumTxt=document.getElementById("albumTxt");
    frontVars.stationListDiv=document.getElementById("cboFrontStationsDiv");
    frontVars.stationList=function(){ return document.getElementById("cboFrontStations"); };
    //In IE we need to reconstruct the whole select when we update it 
    //so this is just a short hand for all the parameters we will need to use so its 
    //data driven
    frontVars.stationListOpts={
	clazz:'',style:'',
	id:'cboFrontStations',onchange:"onStationChange('front');"
    };
    //Image containing default(logo) album cover
    frontVars.defCover = document.getElementById("defAlbumCoverImage");
    //Image containing real albumc ovver that will be changed 
    frontVars.realCover = document.getElementById("realAlbumCoverImage");
    //Element that will have its innerHtml set to the media player
    frontVars.playerContainer=document.getElementById("playerContainer");
    frontVars.playButton=document.getElementById("playButton");
    frontVars.stopButton=document.getElementById("stopButton");
    frontVars.statusIndicator=document.getElementById("statusRegion");
    frontVars.itunesButton=document.getElementById("itunesButton");
    /*  frontVars.volumeSlider=new Control.Slider("volumeSlider","volumeSliderTrack",
      { range: $R(0,100),sliderValue:50,onSlide:function(v){onVolumeChange(v); } });*/
}

function initUserData(){
    try {
	if(window.widget){
	    //Window Widgets
	    UserData.cityPrefs=widget.preferenceForKey("cities");
	    UserData.genrePrefs=widget.preferenceForKey("genres");
	    UserData.stationPref=widget.preferenceForKey("station");
	    UserData.uistate=widget.preferenceForKey("uistate");
	}else{
	    /*
         UserData.cityPrefs="{'-ALL-':1}";
         UserData.genrePrefs="{'Rock':1 }";
         UserData.stationPref="15,1";
       */
	    return;
	}
	DEBUG("Loaded [" + UserData.cityPrefs 
              + "]  and [" + UserData.genrePrefs + "]"
              + " and ["+UserData.stationPref+"]"
              + " and [" +  UserData.uistate + "]");
	UserData.cityPrefs=pref2obj(UserData.cityPrefs);
	UserData.genrePrefs=pref2obj(UserData.genrePrefs);
	DEBUG("Dumps:" + dumpObj(UserData.cityPrefs) + " | " + dumpObj(UserData.genrePrefs));
	if(UserData.cityPrefs && UserData.genrePrefs){
	    var prefFilter=pref2Filter(UserData.cityPrefs,UserData.genrePrefs);
	    DEBUG("Filter from Preferences is " + dumpObj(prefFilter));
	    populateFront(false,function(){
                if(RSData.visible) startRadioDataLoop();
                if(UserData.stationPref){
                    setActive(UserData.stationPref);
                }

            },prefFilter);
	}
    }catch(e){
	DEBUG("Error :" + dumpObj(e));
    }


}
//convert a preference fot city and genres
//int a genuine filter spect
function pref2Filter(cityPref,genrePref){
    var cities=[];
    var genres=[];
    if(cityPref){
	for(var x in cityPref){
	    if(x != "-ALL-") cities.push(x);
	}
    }

    if(genrePref){
	for (var x in genrePref){
	    if(x != "-ALL-") genres.push(x);
	}
    }
    return { 
	'genres': genres,
	city:cities
    };
}
//convert a string to an object
//We store the result of obj.inspect() <-- see prototype
function pref2obj(s){
    var obj={};
    try{
	obj=eval("(" + s + ")");
    }catch(e){
    }
    return obj;
}
function obj2pref(o){
    var hsh=new Hash(o);
    //  return Object.inspect(hsh) ;
    var data="{";
    var first=1;
    for(var x in o){
	if(!first) data +=",";
	first=0;
	data+="'"+ x + "':" + o[x];
    }
    data +="}";
    return data;
}
//Construyct a JS object containing only the selected elements of a 
//select object 
function select2obj(o){
    var ret={};
    var i=0;
    for(i=0;i<o.options.length;++i){
	var x=o.options[i];
	if(x.selected){
	    ret[x.text]=1;
	}
    } 
    return ret;
}
function select2list(o,func){
    var lst=[];
    var i=0;
    for(i=0;i<o.options.length;++i){
	var x=o.options[i];
	if(x.selected){
	    lst.push(func?func(x):x.text);
	}
    }
    return lst;
}

/**
 * This is called after flipping to the back it should populate the 
 * various controls on the back
 */
function populateBack(){
    endStream();
    stopRadioDataLoop();
    //debugger;
    RSData.cache.clear();//Clear the cache
    var cityOptions=buildOptionList(RSData.cityList,UserData.cityPrefs);
    var genreOptions=buildOptionList(RSData.genreList,UserData.genrePrefs);

    //backVars.cityList().innerHTML=cityOptions;
    replaceSelect(backVars.cityList(),backVars.cityListDiv,
                  cityOptions,backVars.cityListOpts);
    //backVars.genreList().innerHTML=genreOptions;
    replaceSelect(backVars.genreList(),backVars.genreListDiv,genreOptions,
                  backVars.genreListOpts);

}

function is_IE(){
    return navigator.userAgent.indexOf("MSIE")>-1;
}
/**
 * This is a work around because in IE
 * you can set the innerHTML of Select elements without 
 * them breaking. 
 * JEEEZE
 */
function replaceSelect(orig,div,options,opts){
    orig.innerHTML=options;
    //@TODO: For Firefox we have done enough
    // div.innerHTML=div.innerHTML;
    //
    //
    if(is_IE()){
	var html="<Select id='" + opts.id + "'"
	    + " style='" + opts.style + "' " 
	    + (opts.multiple?" multiple ":"") 
	    + " class='" + opts.clazz + "' "
	    + (opts.onchange?(" onchange=\"" + opts.onchange + "\" "):"")
	    + " >" 
	    + options  + "</select>";
	div.innerHTML=html;
    }
}

/**
 * Given a List/Array generate a setof <option> elements with the values as the value and display
 * Optionally accepts an object containing names of selected elements
 */
function buildOptionList(lst,selected){
    var options="";
    lst.each(function(x){
        var sel=(selected && selected[x])?"selected":"";
        options+="<option value='" + x + "'  " + sel + "  >" + x + "</option>";
    }
            );
    return options;
}

function savePrefs(fromList){
    if(fromList)
    {
	UserData.cityPrefs=select2obj(backVars.cityList() );
	UserData.genrePrefs=select2obj(backVars.genreList() );
    } 
    cityPref=obj2pref(UserData.cityPrefs);
    genrePref=obj2pref(UserData.genrePrefs); 
    DEBUG("PREFERENCES: city=" + cityPref 
          + "| Genres=" + genrePref  
          + "| Station=" + UserData.stationPref);
    if(window.widget){
	widget.setPreferenceForKey(cityPref,"cities"); 
	widget.setPreferenceForKey(genrePref,"genres");
	widget.setPreferenceForKey(UserData.stationPref,"station");
    }
}

//Resize widget to some specific size
function toSize(sz){
    try{
	if(window.widget){
	    window.resizeTo(sz[0],sz[1])
            /*    }else if(_IG_AdjustIFrameHeight){
              _IG_AdjustIFrameHeight();//ODD we dont get to specify a size
         */
	}
    }catch(e){
    }
}


function buildFilter(){
    var filter={};
    filter['genres']=select2list(backVars.genreList() );
    if(filter['genres'][0]=='-ALL-'){
	filter['genres']="";
    }
    filter['city']=select2list(backVars.cityList() );
    if(filter['city'] =='-ALL-'){
	filter['city']="";
    }
    return filter;
}


/*
 * Construct a line from station information and channel number
 * stationLine(<stationInfo>,index)
 */
function stationLine(x,idx){
    var channel=(idx instanceof Number)?x.uids[idx]:idx;
    var str="[" + x.band + " " + x.frequency + " " + x.call_letters;
    if(x.is_digital == "True"){
	str+= " HD" + channel.channelNumber ;
    }
    str+= "] ";
    if(undefined == channel.song || undefined ==  channel.artist){
	str+="--No schedule information available--";
    }else{
	str+=channel.song + " by " + channel.artist + "";
    }
    return str;
}
function printEx(e){
    var str="{";
    for (x in e){
	str  += x + "=" + e[x]  + "|" ;
    }
    return str + "}";
}
function dumpObj(obj){
    var str="{";
    for (x in obj){
	var val=obj[x];
	str += x + ":" + val  + " , ";
    }
    return str + "}";
}

function valueExtractor(x){
    return x.value;
}
function identity(x){
    return x;
}



function forView(x){
    if(!x || x==null || x== "None") return "Unknown";
    return x;
}

//Display station information
function displayStationInfo(info,channel){
    try {
	if(!backVars.divStationInfo) return;
	var html="";
	html="Artist:" + forView(channel.artist) + "<Br>";
	html+="Song:" + forView(channel.song)  + "<Br>";
	if(channel.album && channel.album!= "None" ){
	    html+="Album:" + forView(channel.album) + "<Br>";
	}
	backVars.divStationInfo.innerHTML=html;

    }catch(e){
	DEBUG("ERROR DISPLAYING STATION INFO:" + e.message);
    }
}

function updateStream(info,channel,dontplay){
    try{
	if(!info){
	    info=RSData.cache.getByUID(RSData.activeStationUID);
	    if(!info){
		//@TODO:Signal erro on UI
		DEBUG("Cannot update Stream");
		return;
	    }
	    info=info[0];
	    channel=info[1];
	}else{
	}

	//    DEBUG("Attemping to Update Front from " + info);
	if(channel){
	    DEBUG("Updating stream from " + info);
	    var streamdata=RadioStreams.getStreamInfo(info,channel);
	    frontVars.streamHandler=streamdata.handler;
	    frontVars.lastStreamUrl=streamdata.streamurl;
	    //if("unknown" != frontVars.streamHandler.state()){
	    //DEBUG("\n------------->Handler ["+frontVars.streamHandler+"]["+frontVars.streamHandler.state()+"]<-----------------");
	    DEBUG("\n------------->Handler ["+frontVars.streamHandler+"]["+frontVars.streamHandler.state()+"]<-----------------");
	    if(frontVars.streamHandler){
		frontVars.playerContainer.innerHTML=streamdata.html;
		if(frontVars.streamHandler.init()) {//init the stream handler.
		    DEBUG("INIT SUCCEEDED");
		    if(dontplay) {
			setUiState("play");
			frontVars.streamHandler.stop();
		    } else {
			onBuffering();
			frontVars.streamHandler.play();
			setUiState("stop");
		    }
		}else{
		    frontVars.initFailed=true;
		    frontVars.streamHandler=null;
		    DEBUG("UNABLE TO INITIALIZE STREAM HANDLER");
		    onNoVlc();
		}
	    }
	}
    }catch(e){
	DEBUG("Error Updating Stream:" +printEx(e));
    }

}
/**
   * Function invoked when the stream handler fails to work
   */
function onNoVlc(){
    setUiState("none"); //Hide play stop
    if(window.widget){
	frontVars.statusIndicator.innerHTML=
            "<a href='#' onclick='gotoVlcDownload();'>VLC is required to  hear audio.</a>";
    }else{
	frontVars.statusIndicator.innerHTML=
            "<a href='"+ RSData.vlcDownloadUrl + "' >VLC is required to hear audio.</a>";

    }
    display(frontVars.statusIndicator);
}

function gotoVlcDownload(){
    widget.openURL(RSData.vlcDownloadUrl);
}


function clearFrontPanel()
{
    var artist=frontVars.artistTxt.innerHTML="Artist";
    var song=frontVars.songTxt.innerHTML="Song Title";
    setUiState("none");
    frontVars.realCover.style.visibility='hidden';
    frontVars.defCover.style.visibility='visible';
    frontVars.itunesButton.style.visibility='hidden';
}

/**
   * Updatethe lcd part of from
   */
function updateFrontPanel(info,channel){
    try{
	if(!info){
            info=RSData.cache.getByUID(RSData.activeStationUID);
            if(!info){
		//@TODO:Signal erro on UI
		DEBUG("Cannot update Front Panel");
		return;
            }
            channel=info[1];
	}else{
	}
	DEBUG("Attemping to Update Front from " + info);
	RSData.itunesurl = null;
	if(channel){
            DEBUG("Updating to Update Front from " + info);
            var artist=frontVars.artistTxt.innerHTML=forView(channel.artist);
            var song=frontVars.songTxt.innerHTML=forView(channel.song);
            frontVars.albumTxt.innerHTML=forView(channel.album);
            if(song ==  "Unknown" 
               || artist == "Unknown"){
		frontVars.artistTxt.innerHTML=Presentation.NoDataStatement;
		frontVars.songTxt.innerHTML=""; 
            }
            DEBUG("Small Image URl= " + channel.smallImageURL);
            if(channel.smallImageURL){
		frontVars.realCover.src=channel.smallImageURL;
		frontVars.defCover.style.visibility='hidden';
		frontVars.realCover.style.visibility='visible'
            }else{
		frontVars.realCover.style.visibility='hidden';
		frontVars.defCover.style.visibility='visible';
            }
            if(channel.itunesurl != null && RSData.hasItunes){
		frontVars.itunesButton.style.visibility='visible';
		RSData.itunesurl = channel.itunesurl;
            }else{
		frontVars.itunesButton.style.visibility='hidden';
            }
	}else{
            frontVars.itunesButton.style.visibility='hidden';
	}
    }catch(e){
	DEBUG("Error Updating Front:" +printEx(e));
    }
}

function onBuffering(){
    display(frontVars.statusIndicator);
    frontVars.statusIndicator.innerHTML="Buffering ...";
}

function clearBuffering()
{
    undisplay(frontVars.statusIndicator);
}

function onError(){
    display(frontVars.statusIndicator);
    frontVars.statusIndicator.innerHTML="Error ...";
    if(frontVars.streamHandler){
	frontVars.streamHandler.stop();//Stop the UI and switch the play state
    }
    setUiState("play");//Set the UI to the play state
}

function onStopped(){
    setUiState("play");//show the stop button    
    if(RSData.streamUpdater != null){
	RSData.streamUpdater.stop();
    }
    RSData.streamUpdater = null;
}

function onPlaying(){
    setUiState("stop"); //show the stop button
    if(RSData.newVersionUrl){
	showNewVersion()
    }else{
	//slow transition from buffering
	if(RSData.lastStreamState != "buffering"){
	    setTimeout(clearBuffering(20));
	}
    }

    // create the oversight timer
    if(RSData.streamUpdater == null){
	RSData.streamUpdater = new PeriodicalExecuter(checkAudio,3600);
    }
}

function display(x){
    x.style.visibility='visible';
}
function undisplay(x){
    x.style.visibility='hidden';
}
function onNoStream(){
    display(frontVars.statusIndicator);
    frontVars.statusIndicator.innerHTML="No Stream";
}
var showstates={
    "loading":onBuffering,
    "buffering":onBuffering,
    "error":onError,
    "playing":onPlaying,
    "stopped":onStopped
};

//Invoked to check state of Streams
function doStreamStateCheck(){
    var handler=frontVars.streamHandler;
    try{
	if(handler){
            var state=handler.state();
            DEBUG("State is ]" + state + "[");
            var func=showstates[state];
            if(func)func();
            RSData.lastStreamState=state;
            return state;
	} else{
            if(frontVars.initFailed) onNoVlc();
	}
    }catch(e){
	DEBUG("Error => " + dumpObj(e));
    }
}


/**
   * User clicked the RadioSherpa link
   */
function onRsLinkClick() {
    if(window.widget){
	widget.openURL(RSData.widgetSite);
    }
}

function gotoNewVersion(){
    widget.openURL(RSData.newVersionUrl);
}

function showNewVersion()
{
    if(RSData.newVersionUrl && RSData.lastUiState != "none"){
	var html="";
	if(window.widget){
            html="<a href='#' onclick='gotoNewVersion()' >" + "A newer version is available!</a>";
	}else{
            html="<a href='" + RSData.newVersionUrl + "'>A newer version is available!</a>";
	}
	frontVars.statusIndicator.innerHTML=html;
	display(frontVars.statusIndicator);

    }

}

var __WHICH_CALLBACK=0;
//Invoke to get the next round of data
function onRadioDataInLoop() {
    DEBUG("\n----------------------->IN RADIO DATA LOOP<-------------------------");
    __WHICH_CALLBACK+=1;
    if((__WHICH_CALLBACK % 2)==1){
	showNewVersion();
	return;
    }
    doStreamStateCheck();
    if(!RSData.waitingForData || RSData.checkConnection > 5){
	DEBUG("\n---------------------->Not waiting for data ["+RSData.checkConnection+"]<-------------------------------");
	RSData.waitingForData=1;
	if(RSData.checkConnection > 0){
            diff = 0;
        }

	//RadioSherpa.getStationUpdateInformation(RSData.activeUIDs.flatten() ,
	RadioSherpa.getUpdateStationInformation(RSData.activeUIDs.flatten(),
						{since:RSData.last_update },
						function(x,timestamp){
						    //      DEBUG("Time Stampe is " + timestamp );
						    if(undefined != timestamp && timestamp > 0)  RSData.last_update=timestamp;
						    RSData.waitingForData=0;
						    if(RSData.checkConnection > 0){
							// connection resumed: restart the stream here?
							if(doStreamStateCheck() == 'playing'){
							    onStationChange('front', true);
							}
						    }
						    RSData.checkConnection = 0;
						    if(x.length > 0){ //Something was updated
							DEBUG("\n------------------->CACHE VALUES STALE: UPDATING CACHE<--------------")
							RSData.cache.update(x,function(s,c){
							    //                            DEBUG("Update (" + dumpObj(s) + ") -> [" + dumpObj(c) + "]");
							    if(c.stationUID == RSData.activeStationUID ){
								updateFrontPanel(s,c);
							    }
							    DEBUG("update for " + c.stationUID);
							    var elt=document.getElementById("f-station-" + c.stationUID);
							    if(elt){
								var newtxt=stationLine(s,c);
								DEBUG("Updating dropdown" + elt.text + " -> " + newtxt );
								elt.text=newtxt;
							    }
							    elt=null;
							});
						    }
						});
    }else{
	DEBUG("\n---------------------->Waiting for data<-------------------------------");
	RSData.checkConnection += 1;
    }
}

//Start radio data loop
function startRadioDataLoop(){
    DEBUG("STARTING RADIO DATA LOOP");
    var updater= RSData.updater ;
    if(updater) updater.stop();
    //Loop is at half the interval but the data is updated every 2 iterations
    RSData.updater=new PeriodicalExecuter(onRadioDataInLoop,RSData.delta/2);
}

/**
* Autoupdate check
*
*/
function initAutoUpdateLoop(){
    DEBUG("STARTING AUTOUPDATE LOOP");
    WidgetUpdate.url = WidgetMeta.getKeyValue("Info.plist","WidgetUpdateUrl")
	|| "http://www.stage.radiosherpa.net:8888/cgi-bin/widget.py/GetLatestVersion";
    WidgetUpdate.loadVersion();
    onAutoUpdateInLoop();
    RSData.autoupdater = new PeriodicalExecuter(onAutoUpdateInLoop,RSData.update_check_delta);	
}

function onNewWidgetVersion(url){
    DEBUG("NEW VERSION IS HERE");
    RSData.newVersionUrl=url;
    showNewVersion();
    //WE can stop this now
    RSData.autoupdater.stop();

}
/**
* Check for updates and see whats up
*/
function onAutoUpdateInLoop(){
    if(RSData.visible)
	WidgetUpdate.checkForUpdate(onNewWidgetVersion);
}


/**
This function builds a list of station and channel  # for
future calls to getStationInformation
The filter is derived from the data on the back of the widget.
If customFilter is provided it is used as the filter instead of the 
data on the back.
Done asynchronously
*/
function buildStationList(after,customfilter){
    var filter=customfilter || buildFilter();
    DEBUG("FILTER = " + dumpObj(filter));
    var active=[]; //active stations
    var uids=[];
    RadioSherpa.getStationList(filter,function(lst){
	//RSData.cache.update(lst);
	lst.each(function(x){
	    var i=0;
	    active.push(x.id);
	    var c=[];
	    for(i=0;i<x.uid_count;++i){
		// DEBUG(dumpObj(x));
		var num=x.uids[i];

		c.push(num);
	    }
	    uids.push(c);
	});
	DEBUG("Station List is " + active);
	RSData.activeStations=active;//update active station list
	RSData.activeUIDs=uids;
	if(after) after();
    });
}
/**
* Populate combo box on front
*/
function populateFront(withactive,after,customfilter){
    //Request full station information. When 
    //is done populate the combo box on the front
    buildStationList(function(){

	//    frontVars.stationList.innerHTML="<option selected='true' >Waiting for List</option>";
	replaceSelect(frontVars.stationList(),
		      frontVars.stationListDiv,
		      "<option selected='true' >Waiting for List</option>",frontVars.stationListOpts);
	DEBUG("Active stations:" + RSData.activeStations);
	DEBUG("Active Channels:" + RSData.activeUIDs);
	var finlist=[];
	RadioSherpa.getStationInformation(RSData.activeStations,0,
					  function(lst,ts){
					      RSData.last_update=ts;//last update time stamp
					      var options="";
					      //Update the data and then get 
					      RSData.cache.update(lst,undefined,true);
					      DEBUG("Active UIDS [" + dumpObj(RSData.activeUIDs) + "]");
					      RSData.activeUIDs.each(function(x){
						  x.each(function(i){
						      try{
							  var dta=RSData.cache.getByUID(i);
							  if(dta) finlist.push(dta);
						      }catch(e){
							  DEBUG("Error for (" + _x[0] + "," + i + ")" + dumpObj(e));
						      }
						  });
					      });
					      
					      //Sort the list by band,Frequency,CallLetter,channel
					      finlist.sort(function(a,b){
						  if(a[0].band < b[0].band) return -1;
						  if(a[0].band > b[0].band) return 1;
						  var c=[1* a[0].frequency , 1* b[0].frequency];
						  if(c[0] < c[1]) return -1;
						  if(c[0] > c[1]) return 1;
						  if(a[0].call_letters < b[0].call_letters) return -1;
						  if(a[0].call_letters > b[0].call_letters) return 1;
						  if(a[1].channelNumber < b[1].channelNumber) return -1;
						  if(a[1].channelNumber > b[1].channelNumber) return 1;
						  return 0;
					      });
					      finlist.each(function(dta){
						  var x=dta[0];
						  var y=dta[1];
						  if(y.streamurl != "" && y.streamurl !=null && y.streamurl!="None"){
						      options+="<option id='f-station-" + y.stationUID + "' "
							  + "value='" + y.stationUID  + "' >" 
							  + stationLine(x,y) + "</option>\n";
						  }
					      });
					      
					      
					      if(options == ""){
						  if(lst.length == 0){
						      options="<option >No stations matched the selection criteria. Please change the criteria on back</option>";
						  }else{
						      options="<option >Select criteria on back</option>";
						  }
					      }else{
						  options = "<option value='-' >"+ Presentation.ChooseStatement + "</option>"+ options;
					      }

					      // frontVars.stationList().innerHTML=options;
					      replaceSelect(frontVars.stationList(),frontVars.stationListDiv,options,
							    frontVars.stationListOpts);

					      //There was an active station update it
					      if(withactive){
						  updateFrontPanel();
					      }
					      //if they rpovided an after run it
					      if(after) after();
					  });
    },customfilter);

}
//Stop radio data loop
function stopRadioDataLoop(){
    if(RSData.updater){
	RSData.updater.stop();   
    }
}
/**
* On Liner function to end stream and do streamhandler cleanup etc
* This function to handle stream cleanup
*/
function endStream(){
    frontVars.initFailed=false;
    if(frontVars.streamHandler){
	try{
	    undisplay(frontVars.statusIndicator);
	    //Try and finalize the stream handler
	    frontVars.streamHandler.finalize();
	    frontVars.lastStreamUrl="";
	    if(RSData.streamUpdater != null){
		RSData.streamUpdater.stop();
	    }
	    RSData.streamUpdater = null;
	    frontVars.streamHandler=null;
	}catch(e){
	}
    }
}

function onStationChange(side,skipsave,dontplay){
    if(side == 'back'){
	//REMOVED THIS CODE
    }else{
	endStream();
	//Front change.
	var active=select2list(frontVars.stationList(),valueExtractor);
	if(active[0] == '-'){
            clearFrontPanel();
	}else if(active.length >0 && active[0] != "-"){
            //Switch active station
            var uid=active[0]; 
            RSData.activeStationUID=uid;
            DEBUG ("Switching Station:" +uid );
            UserData.stationPref =uid;
            if(!skipsave){
		savePrefs();
            }
            //Get 
	    var data=RSData.cache.getByUID(uid);
	    if(data){
		DEBUG("Have data for station!");
		//If not we will wait till the next update and it will be done for us
		updateFrontPanel(data[0],data[1]);
		updateStream(data[0],data[1],dontplay);
	    }else{
		DEBUG("Waiting for data");
	    }
	}

    }
}

function setActive(active)
{
    DEBUG("Setting the active after resuming to ["+active+"]");
    if(active.length > 0){
	//Switch active station
	var info=active.split(","); 
	var i, o = frontVars.stationList(), x;
	DEBUG ("Switching active station ["+active+"]:" + info[0] + " - " + info[1] );
	for(i=0;i<o.options.length;++i){
            x=o.options[i];
            if(x.value == active){
		frontVars.stationList().options[i].selected = true;
		var dontplay=true
		if(UserData.uistate && UserData.uistate=="playing"){
		    dontplay=false
		}
		onStationChange('front',true,dontplay);
		break;
            }
	}
    }
}

/* REMOVE
  function onSelectStation(){
    //Disable button
    backVars.btnSelectStation.disabled=true;
    var active=select2list(backVars.stationList,valueExtractor);
    if(active.length >0){
      var info=active[0].split(","); 
      RSData.activeStationId=info[0];
      RSData.activeStationUID=info[1];
      DEBUG ("Select Station:" + info[0] + " - " + info[1] );
      startRadioDataLoop();//Begin getting radio data
      //Save preferences and flip Back
    }
    populateFront(true);
    flipBack();    
  }*/

/**
  * Flip from back to front.
  */
function flipBack(){
    savePrefs(true);
    hidePrefs();
}

function onBackDone() {
    populateFront(false,function(){
	startRadioDataLoop();
    });
    clearFrontPanel();
    flipBack();
}

/**
  *
  * Events for stream control 
  */
function onPlay(){
    var handler=frontVars.streamHandler;
    DEBUG("PLAY CLICKED ["+handler+"]");
    if(handler){
	onBuffering();
	__WHICH_CALLBACK=1;//next will be buffering for at least 5 deconds
	setUiState("stop");//show the stop button
	handler.play();//attempt to play
    }
}
//state is somewhat misleading
//its which button to show rather than 
//what the state is so play => we are stopped
function setUiState(state){
    if(state == "play"){
	frontVars.playButton.style.visibility="visible";
	frontVars.stopButton.style.visibility="hidden";
	if(window.widget){
            widget.setPreferenceForKey("stopped","uistate");
	}
    }else if(state == "stop") {
        frontVars.playButton.style.visibility="hidden";
        frontVars.stopButton.style.visibility="visible";
        if(window.widget) {
            widget.setPreferenceForKey("playing","uistate");
        }
    }else if(state == "none"){
        frontVars.playButton.style.visibility="hidden";
        frontVars.stopButton.style.visibility="hidden";
    }
    RSData.lastUiState = state;
}

//Volume changed to V  in Range 0-100
function onVolumeChange(v){
    DEBUG("Volume Changed to  " + v );
    var handler=frontVars.streamHandler;
    if(handler){
        handler.volume("set",v);
    }
}

function onStop(){
    DEBUG("STOP CALLED");
    var handler=frontVars.streamHandler;
    if(handler){
        setUiState("play");//show the stop button
        handler.stop();
    }
    clearBuffering();
}

function checkAudio()
{
    if(doStreamStateCheck() == 'playing'){
        onPlay();
    }
}

function onItunes()
{
    // launch the itunes URL
    if(window.widget){
        widget.openURL(RSData.itunesurl);
    }else{
        DEBUG("Would Open:" + RSData.itunesurl);
    } 
}


function itunesTest(cmd){
    if(cmd.status==0){
        RSData.hasItunes=true;
    }else{
        if(window.widget){
            window.alert("NO ITUNES!!!" + cmd.outstringg);
        }
    }
}   

//call to detect itunes
function detectItunes() 
{
    if(window.widget) {
	RSData.hasItunes=false;
	widget.system("ls /Application/iTunes.app/",itunesTest);
    }else{
	RSData.hasItunes=true;
    }
}

var init=true;
try{
    if(staticLoad) init=false;
}catch(E){
}
if(init) initialize();
